/*!\file:  BamgMesh.h
 */ 

#ifndef BAMGMESH_H_
#define BAMGMESH_H_

struct BamgMesh{

	int     NumTriangles;
	double* Triangles;

	int     NumVertices;
	double* Vertices;

	int     NumEdges;
	double* Edges;

	int     NumAllEdges;
	double* AllEdges;

	int     NumSegments;
	double* Segments;
	double* SegmentsMarkers;

	int     NumCrackedEdges;
	double* CrackedEdges;

	int     NumQuadrilaterals;
	double* Quadrilaterals;

	int     NumVerticesOnGeometricVertex;
	double* VerticesOnGeometricVertex;

	int     NumVerticesOnGeometricEdge;
	double* VerticesOnGeometricEdge;

	int     NumEdgesOnGeometricEdge;
	double* EdgesOnGeometricEdge;

	int     NumSubDomains;
	double* SubDomains;

	int     NumSubDomainsFromGeom;
	double* SubDomainsFromGeom;

	double* hVertices;

	int     NumElementConnectivity;
	double* ElementConnectivity;

	int     NumNodalConnectivity;
	double* NodalConnectivity;

	int     NumNodalElementConnectivity;
	double* NodalElementConnectivity;
};

void BamgMeshInit(BamgMesh* bamgmesh);

#ifdef _SERIAL_
#include "mex.h"
void BamgMeshWrite(mxArray** bamgmesh_mat,BamgMesh* bamgmesh);
#endif

#endif
